var ID = 'BlobPipe';
var BlobPipe = function () {
    // console.log("BlobPipe ")
    this.id = ID;
    this.async = true;
    this.pipeline = null;
};

BlobPipe.prototype.init=function(cb){
    //在这之前 把 部分 mpq，  reshash.json加载到 window， 
    window['resFileData'] = {};
    //mpq
    var gamever = getQueryValue("gamever");
    gamever = gamever ? "?"+gamever : "";
    window["__loadZipRes"]("/client_json1/merge/advance.txt"+gamever, window['resFileData'], function() {
        console.log('----加载成功');
    }, this);

    //reshash 测试服不需要拉
    if(GlobalConfig.showLog) {
        cb()
    } else {
        var projectResURL = turnSSL(GlobalConfig.projectResURL);
        //加载资源哈希表
        this.loadUrl(projectResURL + "/reshash1.json" + gamever, (tex) => {
            window['resHashMap'] = JSON.parse(tex);
            console.log('------reshash下载完毕');
            //下载完毕 调用 cb()
            cb()
        })
    }
}
BlobPipe.ID = ID;

BlobPipe.prototype.handle = function(item,callback) {
    //在这里 对json 进行hook
    if(item.type=="uuid"){
        //走我们mpq
        return null;
    }
    if(item.type=="jpg" || item.type=="png" || item.type=="bin" || item.type=="text"||item.type=="js"||item.type=="mp3"){
        var hash = this.getResHash(item.url);
        item.url+= hash ? ("?"+hash) : "";
        return null;    
    }
    // if(item.type!="js")
    {
        return null;
    }
};

BlobPipe.prototype.xhr_load_js = function(url,item,callback){
    var self =this
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;

            function loadHandler() {
                // console.log("onLoadComplete load js ",url)
                item.states[cc.loader.downloader.id] = cc.Pipeline.ItemState.COMPLETE;
                callback(null, item.url);
            }
            self.loadScriptFromMemory(this.response,loadHandler);
            xhr = null;
            // console.log("load js ",url)
        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            self.xhr_load_js(url,item,callback)
        }
    };
    xhr.onerror = function () {
        self.xhr_load_js(url,item,callback)
    }
    xhr.ontimeout = function () {
        self.xhr_load_js(url,item,callback)
    }
    xhr.responseType = "arraybuffer";
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}

BlobPipe.prototype.loadScriptFromUrl= function(e, t) {
    var r = window.document.createElement("script");
    r.type = "text/javascript",
    r.src = e,
    r.onload = t.bind(this),
    document.body.appendChild(r)
}
BlobPipe.prototype.loadScriptFromMemory=function(e, t) {
    var r = this
      , i = URL.createObjectURL(new Blob([e]));
    this.loadScriptFromUrl(i, function(e) {
        // console.log("remove ",i)
        URL.revokeObjectURL(i),
        t.call(r, e)
    })
}
// MD5Pipe.prototype.transformURL = function (url) {
//     var isNativeAsset = !url.startsWith(this.libraryBase);
//     var map = isNativeAsset ? this.md5NativeAssetsMap : this.md5AssetsMap;
//     url = url.replace(UuidRegex, function (match, uuid) {
//         var hashValue = map[uuid];
//         return hashValue ? match + '.' + hashValue : match;
//     });
//     return url;
// };


BlobPipe.prototype.loadUrl = function(url,callback){
    var _self =this
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            xhr = null;
            // console.log("onLoadComplete",url);
            callback(this.response);

        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            _self.loadUrl(url,callback)
        }
    };
    xhr.onerror = function () {
        _self.loadUrl(url,callback)
    }
    xhr.ontimeout = function () {
        _self.loadUrl(url,callback)
    }
    xhr.responseType = "text";
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}

/**
 * 获取资源的hash值
 * @param key :string
 * @returns value :string
 */
BlobPipe.prototype.getResHash = function(key) {
    if(GlobalConfig.showLog) {
        return "";
    }
    //增加缓存
    if(!window['__urlHashMap']) {
        window['__urlHashMap'] = {};
    }
    if(!window['__urlHashMap'][key]) {
        let cryptKey = this.crypt(key);
        if(window['resHashMap'] && window['resHashMap'][cryptKey]) {
            window['__urlHashMap'][key] = window['resHashMap'][cryptKey];

        } else {
            console.error("reshash key ",key);
            window['__urlHashMap'][key] = "1599051886";   //默认值
        }
    }
    return window['__urlHashMap'][key];
}
/**
 * 加密
 * @param str
 * @returns str
 */
BlobPipe.prototype.crypt = function(str) {
    //过滤远程资源路径
    str = str.replace("client1.", "client.");
    str = str.replace("client2.", "client.");
    str = str.replace("client3.", "client.");
    str = str.replace("client4.", "client.");
    var resPath = getRespath();
    str = str.replace(resPath+"/", "");
    //过滤掉项目内资源路径
    var projectResURL = turnSSL(GlobalConfig.projectResURL);
    str = str.replace(projectResURL+"/", "");
    str = md5(str);
    str = str.substr(0,10);

    return str;
}
/**
 * 替换字符串中所有 指定字符串
 * @param {*} str 目标字符串
 * @param {*} ostr 需要替换的内容
 * @param {*} nstr 替换目标内容
 */
BlobPipe.prototype.replaceAll = function (str, ostr, nstr) {
    var reg = new RegExp(ostr, "g"); //创建正则RegExp对象
    return str.replace(reg, nstr);
}


window["extGetJson"] = (item, callback, getJson) => {
    var uuid = item.url.split("/").pop();
    var info = window['resFileData'][uuid]
    if (info) {
        var tmp;
        if (info.jsonObj) {
            tmp = info.jsonObj;
        } else {
            var fileInfo = info;
            var mpqBuff = fileInfo.data;
            var encodedString = '';
            var chunk = 8 * 1024;
            var i;
            var fcount = Math.ceil(fileInfo.length / chunk);
            for (i = 0; i < fcount * chunk; i += chunk) {
                var t_len = chunk
                if ((i + chunk) > fileInfo.length) {
                    t_len = fileInfo.length - i;
                }
                var tmp = new Uint8Array(mpqBuff, fileInfo.begin + i, t_len);
                encodedString += String.fromCharCode.apply(null, tmp);
            }
            var decodedString = decodeURIComponent(escape((encodedString)));//没有这一步中文会乱码
            tmp = JSON.parse(decodedString + "");
            info.jsonObj = tmp;
            fileInfo.data = null;
        }
        callback(null, tmp);
    }
    else {
        //只有json或者plist资源走这里
        //szy 添加atlas格式  动态加载活动spine资源时altas走这里
        if (item.url.indexOf(".json") > 1 || item.url.indexOf(".plist") > 1  || item.url.indexOf(".tmx") > 1|| item.url.indexOf(".atlas") > 1) {
            getJson(item, callback);
        } else if (CC_DEBUG) {
            console.error("加载异常:" + item.url);
        }
    }
}

/*********************** 处理mpq的方法 ***************************/

function __loadUrl (url, type, callback){
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status < 300)) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            xhr = null;
            // console.log("onLoadComplete",url);
            callback(this.response);

        } else if (xhr.status >= 400 && xhr.status < 600) {
            xhr.onreadystatechange = null;
            xhr.onerror = null;
            xhr.ontimeout = null;
            __loadUrl(url,type, callback)
        }
    };
    xhr.onerror = function () {
        __loadUrl(url,type, callback)
    }
    xhr.ontimeout = function () {
        __loadUrl(url,type, callback)
    }
    xhr.responseType = type;
    xhr.open("GET", url, true);
    xhr.timeout = 60000;
    xhr.send();
}


window["__loadZipRes"] = function(zipName, out, callback, context) {
    var projectResURL = turnSSL(GlobalConfig.projectResURL);
    __loadUrl(projectResURL + zipName, "arraybuffer", function(data) {
        window["__getMPQData"](data, out, function() {
            callback.call(context);
            out = null;
        }, this);
    }, function() {
        console.log(zipName + "载入失败,50毫秒后重试:" + zipName);
        setTimeout(function() {
            window["__loadZipRes"](zipName, out, callback, context);
        }, 50)
    })
}

window["__getMPQData"] = function(buffMPQ, out, callBack, context) {
    console.time("buffMPQ")
    var mpqData = new DataView(buffMPQ);
    var offset = 0;
    var filesLen = mpqData.getInt16(offset);
    window["__parseMPQ"](0, filesLen, 2, mpqData, buffMPQ, out, callBack, context);
    out = null;
    console.timeEnd("buffMPQ")
}
window["__parseMPQ"] = function(currentIdx, length, offset, mpqData, mpqBuff, out, callBack, context) {
    for (var findex = 0; findex < length; findex++) {
        var fileInfo = {};
        var fileNameLen = mpqData.getInt16(offset);
        offset += 2;
        var name_8buf = new Uint8Array(mpqBuff, offset, fileNameLen);
        var fileName = String.fromCharCode.apply(null, name_8buf).split(".");

        offset += fileNameLen;
        fileInfo.begin = mpqData.getUint32(offset);
        offset += 4;
        fileInfo.length = mpqData.getUint32(offset);
        offset += 4;
        fileInfo.suffix = fileName[1];
        if (fileInfo.suffix == "json" || fileInfo.suffix == "txt") {
            out[fileName[0] + "." + fileName[1]] = fileInfo;
            fileInfo.data = mpqBuff;
        }
    }
    callBack.call(context);
    out = null;
}
/**
 * 根据当前项目的ssl类型 把url转成对应的url
 * @param {*} url 
 */
function turnSSL(url)
{
    //如果包含 https 就是 ssl
    var isSSL = document.location.protocol == 'https:';
    url = isSSL ? url.replace('http:', 'https:') : url;
    return url;
}

function getRespath() {
    var resPath =  GlobalConfig.ResPath;
    let _res=getQueryValue('res');
    if(_res=='test'){
        resPath=GlobalConfig.ResTestPath;
    }else if(["3", "4"].indexOf(_res) >= 0){//对应Res3 Res4
        resPath=GlobalConfig.ResTestBasePath + _res
    }
    // var isTestRes = getQueryValue('res')=='test';
    // var resPath = isTestRes ? GlobalConfig.ResTestPath : GlobalConfig.ResPath;
    return turnSSL(resPath);
}

function md5(string){
    function md5_RotateLeft(lValue, iShiftBits) {
            return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
    }
    function md5_AddUnsigned(lX,lY){
            var lX4,lY4,lX8,lY8,lResult;
            lX8 = (lX & 0x80000000);
            lY8 = (lY & 0x80000000);
            lX4 = (lX & 0x40000000);
            lY4 = (lY & 0x40000000);
            lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
            if (lX4 & lY4) {
                    return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
            }
            if (lX4 | lY4) {
                    if (lResult & 0x40000000) {
                            return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
                    } else {
                            return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
                    }
            } else {
                    return (lResult ^ lX8 ^ lY8);
            }
    }         
    function md5_F(x,y,z){
            return (x & y) | ((~x) & z);
    }
    function md5_G(x,y,z){
            return (x & z) | (y & (~z));
    }
    function md5_H(x,y,z){
            return (x ^ y ^ z);
    }
    function md5_I(x,y,z){
            return (y ^ (x | (~z)));
    }
    function md5_FF(a,b,c,d,x,s,ac){
            a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_F(b, c, d), x), ac));
            return md5_AddUnsigned(md5_RotateLeft(a, s), b);
    };
    function md5_GG(a,b,c,d,x,s,ac){
            a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_G(b, c, d), x), ac));
            return md5_AddUnsigned(md5_RotateLeft(a, s), b);
    };
    function md5_HH(a,b,c,d,x,s,ac){
            a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_H(b, c, d), x), ac));
            return md5_AddUnsigned(md5_RotateLeft(a, s), b);
    };
    function md5_II(a,b,c,d,x,s,ac){
            a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_I(b, c, d), x), ac));
            return md5_AddUnsigned(md5_RotateLeft(a, s), b);
    };
    function md5_ConvertToWordArray(string) {
            var lWordCount;
            var lMessageLength = string.length;
            var lNumberOfWords_temp1=lMessageLength + 8;
            var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
            var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
            var lWordArray=Array(lNumberOfWords-1);
            var lBytePosition = 0;
            var lByteCount = 0;
            while ( lByteCount < lMessageLength ) {
                    lWordCount = (lByteCount-(lByteCount % 4))/4;
                    lBytePosition = (lByteCount % 4)*8;
                    lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
                    lByteCount++;
            }
            lWordCount = (lByteCount-(lByteCount % 4))/4;
            lBytePosition = (lByteCount % 4)*8;
            lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
            lWordArray[lNumberOfWords-2] = lMessageLength<<3;
            lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
            return lWordArray;
    };
    function md5_WordToHex(lValue){
            var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
            for(lCount = 0;lCount<=3;lCount++){
                    lByte = (lValue>>>(lCount*8)) & 255;
                    WordToHexValue_temp = "0" + lByte.toString(16);
                    WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
            }
            return WordToHexValue;
    };
    function md5_Utf8Encode(string){
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
            for (var n = 0; n < string.length; n++) {
                    var c = string.charCodeAt(n);
                    if (c < 128) {
                            utftext += String.fromCharCode(c);
                    }else if((c > 127) && (c < 2048)) {
                            utftext += String.fromCharCode((c >> 6) | 192);
                            utftext += String.fromCharCode((c & 63) | 128);
                    } else {
                            utftext += String.fromCharCode((c >> 12) | 224);
                            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                            utftext += String.fromCharCode((c & 63) | 128);
                    }
            }
            return utftext;
    };
    var x=Array();
    var k,AA,BB,CC,DD,a,b,c,d;
    var S11=7, S12=12, S13=17, S14=22;
    var S21=5, S22=9 , S23=14, S24=20;
    var S31=4, S32=11, S33=16, S34=23;
    var S41=6, S42=10, S43=15, S44=21;
    string = md5_Utf8Encode(string);
    x = md5_ConvertToWordArray(string);
    a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
    for (k=0;k<x.length;k+=16) {
            AA=a; BB=b; CC=c; DD=d;
            a=md5_FF(a,b,c,d,x[k+0], S11,0xD76AA478);
            d=md5_FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
            c=md5_FF(c,d,a,b,x[k+2], S13,0x242070DB);
            b=md5_FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
            a=md5_FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
            d=md5_FF(d,a,b,c,x[k+5], S12,0x4787C62A);
            c=md5_FF(c,d,a,b,x[k+6], S13,0xA8304613);
            b=md5_FF(b,c,d,a,x[k+7], S14,0xFD469501);
            a=md5_FF(a,b,c,d,x[k+8], S11,0x698098D8);
            d=md5_FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
            c=md5_FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
            b=md5_FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
            a=md5_FF(a,b,c,d,x[k+12],S11,0x6B901122);
            d=md5_FF(d,a,b,c,x[k+13],S12,0xFD987193);
            c=md5_FF(c,d,a,b,x[k+14],S13,0xA679438E);
            b=md5_FF(b,c,d,a,x[k+15],S14,0x49B40821);
            a=md5_GG(a,b,c,d,x[k+1], S21,0xF61E2562);
            d=md5_GG(d,a,b,c,x[k+6], S22,0xC040B340);
            c=md5_GG(c,d,a,b,x[k+11],S23,0x265E5A51);
            b=md5_GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
            a=md5_GG(a,b,c,d,x[k+5], S21,0xD62F105D);
            d=md5_GG(d,a,b,c,x[k+10],S22,0x2441453);
            c=md5_GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
            b=md5_GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
            a=md5_GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
            d=md5_GG(d,a,b,c,x[k+14],S22,0xC33707D6);
            c=md5_GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
            b=md5_GG(b,c,d,a,x[k+8], S24,0x455A14ED);
            a=md5_GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
            d=md5_GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
            c=md5_GG(c,d,a,b,x[k+7], S23,0x676F02D9);
            b=md5_GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
            a=md5_HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
            d=md5_HH(d,a,b,c,x[k+8], S32,0x8771F681);
            c=md5_HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
            b=md5_HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
            a=md5_HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
            d=md5_HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
            c=md5_HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
            b=md5_HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
            a=md5_HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
            d=md5_HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
            c=md5_HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
            b=md5_HH(b,c,d,a,x[k+6], S34,0x4881D05);
            a=md5_HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
            d=md5_HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
            c=md5_HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
            b=md5_HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
            a=md5_II(a,b,c,d,x[k+0], S41,0xF4292244);
            d=md5_II(d,a,b,c,x[k+7], S42,0x432AFF97);
            c=md5_II(c,d,a,b,x[k+14],S43,0xAB9423A7);
            b=md5_II(b,c,d,a,x[k+5], S44,0xFC93A039);
            a=md5_II(a,b,c,d,x[k+12],S41,0x655B59C3);
            d=md5_II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
            c=md5_II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
            b=md5_II(b,c,d,a,x[k+1], S44,0x85845DD1);
            a=md5_II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
            d=md5_II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
            c=md5_II(c,d,a,b,x[k+6], S43,0xA3014314);
            b=md5_II(b,c,d,a,x[k+13],S44,0x4E0811A1);
            a=md5_II(a,b,c,d,x[k+4], S41,0xF7537E82);
            d=md5_II(d,a,b,c,x[k+11],S42,0xBD3AF235);
            c=md5_II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
            b=md5_II(b,c,d,a,x[k+9], S44,0xEB86D391);
            a=md5_AddUnsigned(a,AA);
            b=md5_AddUnsigned(b,BB);
            c=md5_AddUnsigned(c,CC);
            d=md5_AddUnsigned(d,DD);
    }
return (md5_WordToHex(a)+md5_WordToHex(b)+md5_WordToHex(c)+md5_WordToHex(d)).toLowerCase();
}